/* AUTOGENERATED FILE -- DO NOT EDIT */

/**
 * @file
 * @brief Client stubs for the example protocol
 * @addtogroup example_client
 * @{
 */

#ifndef EXAMPLE_CLIENT_H
#define EXAMPLE_CLIENT_H

#include "example_minirpc.h"

/**
 * @brief The role definition for the example client
 */
extern const struct mrpc_protocol * const example_client;

/**
 * @brief Call server's @c choose_color procedure and wait for a reply
 * @param	conn
 *	The connection to use
 * @param	in
 *	The argument to the @c choose_color procedure
 * @return ::MINIRPC_OK or an error code
 * @sa free_example_color_choice()
 *
 * @c in must be allocated by the application, and may be freed by the
 * application after the call returns.
 *
 * A return code of MINIRPC_OK indicates that the server completed the
 * procedure call and returned a success code.  A positive return code
 * is a protocol-specific error returned by the server's procedure handler.
 * A negative return code is a miniRPC error generated either by the local
 * or remote system.
 */
mrpc_status_t example_choose_color(struct mrpc_connection *conn,
			example_color_choice *in);

/**
 * @brief Call server's @c get_num_colors procedure and wait for a reply
 * @param	conn
 *	The connection to use
 * @param[out]	out
 *	The structure returned from the @c get_num_colors procedure
 * @return ::MINIRPC_OK or an error code
 * @sa free_example_count()
 *
 * @c *out is allocated by miniRPC but must be freed by the application.
 *
 * A return code of MINIRPC_OK indicates that the server completed the
 * procedure call and returned an example_count structure in @c *out.
 * A positive return code is a protocol-specific error returned by the server's
 * procedure handler.  A negative return code is a miniRPC error generated
 * either by the local or remote system.  If the return code is not
 * MINIRPC_OK, @c *out is NULL on return.
 */
mrpc_status_t example_get_num_colors(struct mrpc_connection *conn,
			example_count **out);

/**
 * @brief Callback function for asynchronous @c choose_color call
 * @param	conn_private
 *	The cookie for the originating connection
 * @param	msg_private
 *	The cookie passed to example_choose_color_async()
 * @param	msg
 *	An opaque handle to the reply message
 * @param	status
 *	The status code returned by the @c choose_color call
 */
typedef void (example_choose_color_callback_fn)(void *conn_private,
			void *msg_private, struct mrpc_message *msg,
			mrpc_status_t status);

/**
 * @brief Callback function for asynchronous @c get_num_colors call
 * @param	conn_private
 *	The cookie for the originating connection
 * @param	msg_private
 *	The cookie passed to example_get_num_colors_async()
 * @param	msg
 *	An opaque handle to the reply message
 * @param	status
 *	The status code returned by the @c get_num_colors call
 * @param	reply
 *	The Count structure returned by the @c get_num_colors call
 *
 * @c reply is valid if @c status is MINIRPC_OK, NULL otherwise.  @c reply
 * is freed by miniRPC after the callback returns.
 */
typedef void (example_get_num_colors_callback_fn)(void *conn_private,
			void *msg_private, struct mrpc_message *msg,
			mrpc_status_t status, example_count *reply);

/**
 * @brief Call server's @c choose_color procedure and fire a callback when it
 *		completes
 * @param	conn
 *	The connection to use
 * @param	callback
 *	The function to call when the procedure completes
 * @param	private
 *	An application-specific cookie to be passed to the callback function
 * @param	in
 *	The structure parameter to be passed to the server
 * @return MINIRPC_OK or an error code
 *
 * Initiates a @c choose_color remote procedure call and returns immediately.
 * If the return code is not MINIRPC_OK, miniRPC was unable to transmit
 * the procedure call to the remote system.
 *
 * The callback function is executed from an event dispatcher; see
 * @ref event for details.
 */
mrpc_status_t example_choose_color_async(struct mrpc_connection *conn,
			example_choose_color_callback_fn *callback,
			void *private, example_color_choice *in);

/**
 * @brief Call server's @c get_num_colors procedure and fire a callback when
 *		it completes
 * @param	conn
 *	The connection to use
 * @param	callback
 *	The function to call when the procedure completes
 * @param	private
 *	An application-specific cookie to be passed to the callback function
 * @return MINIRPC_OK or an error code
 *
 * Initiates a @c get_num_colors remote procedure call and returns immediately.
 * If the return code is not MINIRPC_OK, miniRPC was unable to transmit
 * the procedure call to the remote system.
 *
 * The callback function is executed from an event dispatcher; see
 * @ref event for details.
 */
mrpc_status_t example_get_num_colors_async(struct mrpc_connection *conn,
			example_get_num_colors_callback_fn *callback,
			void *private);

/**
 * @brief Send a @c crayon_selected message to the server
 * @param	conn
 *	The connection to use
 * @param	in
 *	The data to be included in the @c crayon_selected message
 * @return ::MINIRPC_OK or an error code
 * @sa free_example_color()
 *
 * @c in must be allocated by the application, and may be freed by the
 * application after the call returns.
 *
 * A return code of MINIRPC_OK indicates that the message was successfully
 * queued for transmission.  It does not indicate that the message has left
 * the local system or that the message was received by the server.
 * Because @c crayon_selected is not defined as a procedure call in the
 * protocol definition, the server has no opportunity to respond to the
 * message.
 */
mrpc_status_t example_crayon_selected(struct mrpc_connection *conn,
			example_color *in);

/**
 * @}
 */

#endif
